<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use ZeedhiUser\Services\AccessControl\Environment;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\MAN\Services\PerfacessparcOperadorRepository;

class PerfacessparcOperador extends \ZeedhiUser\Controllers\General\ZhuCrud {

    protected $dataSourceName = "perfacessparc";
    protected $PerfacessparcOperadorRepository;
    protected  $salesMessage;

    public function __construct(Manager $dataSourceManager, Environment $environment, 
                                ParameterBag $parameterBag, PerfacessparcOperadorRepository $PerfacessparcOperadorRepository
                               ) {
        $this->PerfacessparcOperadorRepository = $PerfacessparcOperadorRepository;

        parent::__construct($dataSourceManager, $environment, $parameterBag);
    }


    public function save(DTO\Request\DataSet $request, DTO\Response $response) {
    	$operNotInsert=0;
        $index = 1;
        $rows = [];
        try {
            $perfilmax = $this->PerfacessparcOperadorRepository->getMaxNrPerfAcessParc();
            $maxNRPERFACESSPARC = $perfilmax[0]['MAXNRPERFACESSPARC'];
            foreach($request->getDataSet()->getRows() as $row) {
	        	if ($row->get("__is_new")) {
	        		$nrperfilacesso = $row->get("NRPERFILACESSO");
	                $nrparcnegocio = $row->get("NRPARCNEGOCIO");
	                $validaNovo =  $this->PerfacessparcOperadorRepository->findOperadorInGroup($nrparcnegocio,$nrperfilacesso);
	                if(empty($validaNovo[0])){
		                $row->set("NRPERFACESSPARC", $maxNRPERFACESSPARC+$index);
		                $dtvalperfilparc = null;
		                $index++;
		                $nrorg = 1;           
			            $idativo = 'S';
			            $nrusergroup = 1;
			            $nrperfacessopai = null;
			            $nrperfacessparc = $maxNRPERFACESSPARC+$index;
			            $perfilacesso = $this->PerfacessparcOperadorRepository->salvaPerfilAcessoParcOperador($nrperfacessparc, $nrorg, $idativo, $dtvalperfilparc,
		                $nrparcnegocio, $nrperfilacesso);
		                $rows[] = array('NRPERFACESSPARC' => $nrperfacessparc);
	                }else{
	                	$operNotInsert ++;
	                }     
	            }          
	        } 
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage()));
            $maxNRPERFACESSPARC = 1;
        }
    	
    	if ($operNotInsert > 0){
    		 $response->addMessage(new DTO\Response\Message('Já foram inseridos '.$operNotInsert.' operadores.'));
    	}
       return $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('PerfilAcessoParc', $rows));
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response){
    	
    	$params = $request->getFilterCriteria()->getConditions();
    	$nrperfilacesso = $params[1]["value"];
    	$nrorg = $params[0]["value"];
    	$rows = $this->PerfacessparcOperadorRepository->getAllPerfAcesso($nrorg, $nrperfilacesso);
    	return $response->addDataSet(new DataSet($this->dataSourceName, $rows));
    }

    public function delete(DTO\Request\DataSet $request, DTO\Response $response){
    	$rows = $request->getDataSet()->getRows();
    	foreach ($rows as $row) {
    	    $perfisToDelete[] = $row->get("NRPERFACESSPARC");
    	    $nrperfil = $row->get("NRPERFACESSPARC");
    	    $this->PerfacessparcOperadorRepository->deletePerfAcessoParc($nrperfil);
        }
        try {
       	   	$rows = $perfisToDelete;
		    $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('PerfilAcessoParc', $rows));
        }catch (\Exception $e) {
		        $response->addMessage(new DTO\Response\Message($e->getMessage()));
		}
    }
}