<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;

class RelProdModTipocons extends CrudWithParameterBag {

    protected $elProdModTipocons;
    protected $utilService;
    protected $dataSourceName = 'vnd55020_relProdModTipocons';
    protected $parameterBagColumns = array('CDFILIAL', 'TCDFILIAL', 'CDOPERADOR', 'CDLOJA', 'TCDLOJA', 'DATAINI', 'DATAFIN', 'MODALIDADE', 'TMODALIDADE', 'FLAGBALTAA', 'CDTIPOCONS', 'TCDTIPOCONS', 'SC', 'NRORG', 'RELATORIO', 'DTENTRVENDA', 'TIPORELATORIO');
    
    public function __construct($dataSourceManager, $parameterBag, Services\RelProdModTipocons $elProdModTipocons, Utilities\Util $utilService) {
        parent::__construct($dataSourceManager, $parameterBag);
        $this->relProdModTipocons = $elProdModTipocons;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        ini_set('max_execution_time', 3600);
        ini_set('memory_limit', '1G');
        set_time_limit(3600);
        
        $result = [];
        
        $conditions = $this->utilService->getParamsAsArray($request);
        $conditions = $this->relProdModTipocons->buildParamsFaturamento($conditions);
        
        if(isset($conditions['DATAINI']) && !empty($conditions['DATAINI']) && isset($conditions['DATAFIN']) && !empty($conditions['DATAFIN'])) {
            foreach($conditions as $key => $value) {
                $dataSourceFilter[] = $condition = array(
                    "columnName" => $key,
                    "operator"=> "=",
                    "value"=> $value
                );
            }
            
            // para o CTRL+F funcionar
            for($i = 0; $i < count($conditions); $i++) {
                if(strpos($dataSourceFilter[$i]["columnName"], '|') != false) {
                    $dataSourceFilter[$i]["operator"] = "MAPPED_LIKE_ALL";
                }
            }
            
            $newRequest = new DTO\Request\Filter (
                new FilterCriteria(
                    $request->getFilterCriteria()->getDataSourceName(),
                    $dataSourceFilter,
                    $request->getFilterCriteria()->getPage(),
                    $request->getFilterCriteria()->getPageSize()
                ),
                $request->getMethod(),
                $request->getRoutePath(),
                $request->getUserId()
            );
            
            $result = parent::find($newRequest, $response);
        }
        
        return $result;
    }
}

