<?php
namespace Teknisa\MAN\Services;

use Teknisa\MAN\Factories\ConfigMesaAmbienteModel;
use Teknisa\MAN\Utilities;

class ConfigMesaAmbienteService {

    /**
     * @var 
     */

    protected $ConfigMesaAmbienteModel;
    protected $entityManager;

	public function __construct(ConfigMesaAmbienteModel $ConfigMesaAmbienteModel, \Doctrine\ORM\EntityManager $entityManager)  {
        $this->ConfigMesaAmbienteModel = $ConfigMesaAmbienteModel;
		$this->entityManager = $entityManager;
	}


    /**
     * @return int
     */
    public function getNextCodigo($CDFILIAL) {    
        $codigoRow = $this->ConfigMesaAmbienteModel->getMaxCodigo($CDFILIAL); 
        $codigo = $codigoRow[0]['MAX_CDSALA'];

        return !is_null($codigo) ? ++$codigo : 1;
    }

    public function findCodigo($sgsala, $nrorg){
        $params = array(
            "SGSALA" => $sgsala,
            "NRORG" => $nrorg
     	); 
        return $this->entityManager->getConnection()->fetchAll(self::GET_SALA,$params);
    }
    
    public function getMesasInterval($nrorg, $cdFilial, $cdLoja, $cdSala, $mesaIni, $mesaFin) {
        $params = array(
            ":NRORG" => $nrorg,
            ":CDFILIAL" => $cdFilial,
            ":CDLOJA" => $cdLoja,
            ":CDSALA" => $cdSala,
            ":NRMESAINI" => $mesaIni,
            ":NRMESAFIN" => $mesaFin
     	); 
     	
        return $this->entityManager->getConnection()->fetchAll(self::GET_MESAS, $params);
    }
    
    public function getMesa($NRORG, $CDFILIAL, $CDLOJA, $NRMESA) {
        $params = array(
            ":NRORG"    => $NRORG,
            ":CDFILIAL" => $CDFILIAL,
            ":CDLOJA"   => $CDLOJA,
            ":NRMESA"   => $NRMESA
     	); 
        return $this->entityManager->getConnection()->fetchAll(self::GET_MESA, $params);
    }
    
    public function getNrMesa($nrorg, $cdFilial, $cdLoja) {
        $params = array(
            ":NRORG" => $nrorg,
            ":CDFILIAL" => $cdFilial,
            ":CDLOJA" => $cdLoja,
     	); 
     	
        return $this->entityManager->getConnection()->fetchAll(self::GET_NRMESA, $params);
    }
  
  
    const GET_MESAS = "
    SELECT NRMESA  
      FROM MESA
      WHERE CDFILIAL = :CDFILIAL
        AND CDLOJA = :CDLOJA
        AND NRORG = :NRORG
        AND NRMESA BETWEEN :NRMESAINI AND :NRMESAFIN
    ";
  
    const GET_MESA = "
     SELECT NRMESA AS MESA, CDSALA FROM MESA WHERE CDFILIAL = :CDFILIAL
        AND CDLOJA = :CDLOJA
        AND NRORG = :NRORG
        AND NRMESA = :NRMESA
    ";   
    
     const GET_NRMESA = "
    SELECT MAX(NRMESA) AS NRMESA  
      FROM MESA
      WHERE CDFILIAL = :CDFILIAL
        AND CDLOJA = :CDLOJA
        AND NRORG = :NRORG
        AND IDATIVO = 'S'
    "; 
} 