<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class ProdutosBloqueadosService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        
    }
   
    
    public function bloqueiaProduto($produtos, $isNew) {
        $this->entityManager->getConnection()->beginTransaction();
        $all = false;
        try{
            foreach ($produtos as $prod) {
            	$params = array(
                	":CDFILIAL" => $prod['CDFILIAL'],
			     	":CDLOJA" => $prod['CDLOJA'],
			     	":CDPRODUTO" => $prod['CDPRODUTO'],
			     	":CDOPERADOR" => $prod['CDOPERADOR'],
			     	":NRDIASEMANABLOQ" => $prod['NRDIASEMANABLOQ'],
			     	":NRORG" => $prod['NRORG']
                );
                
                if ($prod['NRDIASEMANABLOQ'] === 'T'){
			     	$all = true;
			     	$paramAll = $params;
			    }
                $this->entityManager->getConnection()->executeQuery(self::INSERT_BLOCKED_PRODUCT, $params);
                
                if ($all){
            		$this->entityManager->getConnection()->executeQuery(self::DELETE_ALL_SINGLE_DAYS_BLOCKED_PRODUCT, $paramAll);
	            }
	            else{
	            	$this->entityManager->getConnection()->executeQuery(self::DELETE_ALL_FROM_BLOCKED_PRODUCT, $params);
	            }
            }
           
            
            $this->entityManager->getConnection()->commit();
        }catch(Exception $e){
            $this->entityManager->getConnection()->rollBack();
        }
    }
    
  
	/*public function bloqueiaProduto($produtos, $isNew) {
		$this->entityManager->getConnection()->beginTransaction();
		try {
		    foreach($produtos as $prod) {
				$params = array(
				   	":CDFILIAL" => $prod['CDFILIAL'],
			     	":CDLOJA" => $prod['CDLOJA'],
			     	":CDPRODUTO" => $prod['CDPRODUTO'],
			     	":CDOPERADOR" => $prod['CDOPERADOR'],
			     	":NRDIASEMANABLOQ" => $prod['NRDIASEMANABLOQ'],
			     	":NRORG" => $prod['NRORG']
			 	);
				$this->entityManager->getConnection()->executeQuery(self::INSERT_BLOCKED_PRODUCT, $params);
				
			}
			$this->entityManager->getConnection()->commit();
		} catch (\Exception $e) {
		$this->entityManager->getConnection()->rollBack();
		}
	}*/
	
	public function desbloqueiaProduto($NRORG, $CDFILIAL, $CDLOJA, $CDPRODUTO, $CDOPERADOR, $NRDIASEMANABLOQ) {
	      $params = array(
         	":CDFILIAL" =>	$CDFILIAL,
         	":CDLOJA" =>	$CDLOJA,
         	":CDPRODUTO" =>	$CDPRODUTO,
         	":CDOPERADOR" =>	$CDOPERADOR,
         	":NRDIASEMANABLOQ" =>	$NRDIASEMANABLOQ,
         	":NRORG" =>	$NRORG
     		);
     		$response = $this->entityManager->getConnection()->executeQuery(self::DELETE_BLOCKED_PRODUCT, $params);
	    return $response;
	}
	
	const INSERT_BLOCKED_PRODUCT = "
    	INSERT INTO PRODBLOQVND
    		(CDFILIAL, CDLOJA, CDPRODUTO, CDOPERADOR, DTHRBLOQUEIO, NRDIASEMANABLOQ, NRORG)
    	 VALUES
    		(:CDFILIAL, :CDLOJA, :CDPRODUTO, :CDOPERADOR, TO_DATE(SYSDATE, 'DD/MM/YYYY HH24:MI:SS'), :NRDIASEMANABLOQ, :NRORG)
    ";
    
    const DELETE_ALL_DAYS = "
    	DELETE FROM PRODBLOQVND
    	 WHERE CDFILIAL 	   = :CDFILIAL
    	   AND CDLOJA   	   = :CDLOJA
    	   AND NRORG		   = :NRORG
    	   AND CDPRODUTO	   = :CDPRODUTO
    ";
    
    const SELECT_DAYS_BLOCKED = "
    	SELECT * FROM PRODBLOQVND 
    	 WHERE CDFILIAL = :CDFILIAL 
    	  AND CDLOJA = :CDLOJA 
    	  AND NRORG = :NRORG 
    	  AND CDPRODUTO	= :CDPRODUTO
    	  ORDER BY NRDIASEMANABLOQ";
    
    const DELETE_BLOCKED_PRODUCT = "
    	DELETE FROM PRODBLOQVND
    	 WHERE CDFILIAL 	   = :CDFILIAL
    	   AND CDLOJA   	   = :CDLOJA
    	   AND CDPRODUTO	   = :CDPRODUTO
    	   AND NRDIASEMANABLOQ = :NRDIASEMANABLOQ
    	   AND NRORG		   = :NRORG
    ";
    
    const DELETE_ALL_SINGLE_DAYS_BLOCKED_PRODUCT = "
    	DELETE FROM PRODBLOQVND
    	 WHERE CDFILIAL 	   = :CDFILIAL
    	   AND CDLOJA   	   = :CDLOJA
    	   AND NRORG		   = :NRORG
    	   AND CDPRODUTO	   = :CDPRODUTO
    	   AND NRDIASEMANABLOQ <> 'T'
    ";
    
    const DELETE_ALL_FROM_BLOCKED_PRODUCT = "
    	DELETE FROM PRODBLOQVND
    	 WHERE CDFILIAL 	   = :CDFILIAL
    	   AND CDLOJA   	   = :CDLOJA
    	   AND NRORG		   = :NRORG
    	   AND CDPRODUTO	   = :CDPRODUTO
    	   AND NRDIASEMANABLOQ = 'T'
    ";
}